import 'reflect-metadata';
import { DynamicModule, ModuleMetadata, Type } from '@nestjs/common';
import { Saga as SagaCore } from './core';
declare type WithSaga<T, S, R> = {
    saga: SagaCore<S, R>;
} & T;
export declare function Saga<S>(command: Type<S>): <X, T extends Type<WithSaga<X, S, unknown>>>(target: T) => T;
export interface SagaModuleRegisterParams extends Pick<ModuleMetadata, 'imports' | 'providers'> {
    sagas: Type<WithSaga<any, any, any>>[];
}
export declare class SagaModule {
    static register(params: SagaModuleRegisterParams): DynamicModule;
}
export {};
