"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SagaModule = exports.Saga = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
require("reflect-metadata");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const cqrs_1 = require("@nestjs/cqrs");
const __SAGA_HANDLER__ = '__SAGA_HANDLER__';
function Saga(command) {
    return (target) => {
        target.prototype.execute = function execute(cmd) {
            return this.saga.execute(cmd);
        };
        Reflect.defineMetadata(__SAGA_HANDLER__, command, target);
        return (0, common_1.Injectable)({ scope: common_1.Scope.REQUEST })(target);
    };
}
exports.Saga = Saga;
class SagaModule {
    static register(params) {
        return {
            imports: [cqrs_1.CqrsModule, ...(params.imports || [])],
            module: SagaModule,
            providers: [
                ...(params.providers || []),
                ...params.sagas.flatMap((saga) => {
                    const cmdType = Reflect.getMetadata(__SAGA_HANDLER__, saga);
                    let SagaCommandHandler = class SagaCommandHandler {
                        constructor(moduleRef) {
                            this.moduleRef = moduleRef;
                        }
                        async execute(cmd) {
                            const s = await this.moduleRef.create(saga);
                            s.saga.bind(s);
                            return s.execute(cmd);
                        }
                    };
                    SagaCommandHandler = __decorate([
                        (0, cqrs_1.CommandHandler)(cmdType),
                        __metadata("design:paramtypes", [core_1.ModuleRef])
                    ], SagaCommandHandler);
                    Object.defineProperty(SagaCommandHandler, 'name', {
                        writable: true,
                        value: [cmdType.name, 'SagaDispatcher'].join(''),
                    });
                    return [saga, SagaCommandHandler];
                }),
            ],
        };
    }
}
exports.SagaModule = SagaModule;
//# sourceMappingURL=nest.js.map